﻿@model IEnumerable<ExploreApilkasiCuti.Models.MasterJabatan>

@{
    ViewBag.Title = "Master Jabatan";
    string collumVisible = "";
    collumVisible = "{'targets': [8], 'visible': true}";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section HeadLibrary{

    <link rel="stylesheet" href="~/AdminLTE/plugins/fontawesome-free/css/all.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE//plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css" />
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css" />
    <!-- iCheck for checkboxes and radio inputs -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/icheck-bootstrap/icheck-bootstrap.min.css">
    <!-- Bootstrap Color Picker -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Bootstrap4 Duallistbox -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
}

<style>
    .content-table {
        border-collapse: collapse;
        margin: 25px 0;
        min-width: 1000px;
        box-shadow: 0 0 20px rgba(0, 0, 0, 0.15);
        width: 100%;
    }

    /* if the browser window is at least 800px-s wide: */
    @@media screen and (min-width: 800px) {
        table {
            width: 90%;
        }
    }

    /* if the browser window is at least 1000px-s wide: */
    @@media screen and (min-width: 1000px) {
        table {
            width: 80%;
        }
    }

    .content-table thead tr {
        background-color: #10ad21;
        color: #ffffff;
        text-align: left;
    }

    .content-table tr, td {
        border: solid black 0.5px;
    }

    .content-table th, td {
        padding: 12px 10px;
        border: solid black 0.5px;
    }

    #dataMasterJabatan_filter .iconSearch {
        float: left;
        display: inline-block;
    }

    .help-block {
        color: red;
    }

    .has-error {
        color: red;
    }
</style>

<div class="card">
    <div class="card-header">
        <h3 class="card-title" > Master Data Jabatan</h3>
    </div>
    <div class="card-body">
        <!--<div class="dataTables_wrapper dt-bootstrap4">-->
        <div>
            <div class="row">
                <button type="button" class="btn btn-success" onclick="show_modal_insertupdate('ADD')">
                    <i class="fa fa-plus-circle fa"></i>  Tambah Data
                </button>
                @*<div class="col-sm-12 col-md-12">
                        <a onclick="show_modal_insertupdate('ADD')"><i class="fa fa-plus-circle fa-2x"></i></a>
                    </div>*@
                <div class="mt-3 col-md-12"></div>
            </div>
            <div class="row">
                <div class="col-sm-12">
                    <!--<table id="dataMasterJabatan" class="table table-bordered table-striped dataTable dtr-inline" role="grid" aria-describedby="dataMasterJabatan_info">-->
                    <table id="dataMasterJabatan" class="table table-bordered table-striped" style="color:black">
                        <thead>
                            <tr>
                                <th>
                                    ID
                                </th>
                                <th>
                                    Nama Jabatan
                                </th>
                                <th>
                                    ID Saldo
                                </th>
                                <th>
                                    Created By
                                </th>
                                <th>
                                    Created Date
                                </th>
                                <th>
                                    Changed By
                                </th>
                                <th>
                                    Changed Date
                                </th>
                                <th style="width:65px">
                                    Action
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            @*@foreach (var item in Model)
                                {
                                    <tr id="@item.id_jabatan">
                                        <td>
                                            @Html.DisplayFor(modelItem => item.id_jabatan)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.nama_jabatan)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.id_saldo_ulang_bulan)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.created_by)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.created_date)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.changed_by)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.changed_date)
                                        </td>
                                        <td>
                                            <button class="btn btn-primary" id="delJabatan" onclick="get_id_delete()"> <i class="fa fa-trash-alt"></i></button>
                                            <button class="btn btn-danger" onclick=""> <i class="fas fa-edit"></i></button>
                                        </td>
                                    </tr>
                                }*@
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="deleteJabatan" tabindex="-1" data-backdrop="static" role="dialog" aria-labelledby="deleteJabatanLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" style="text-align:center" id="deleteJabatanLabel">Konfirmasi</h5>
                <button class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="false">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <h6 id="deleteJabatanBody"></h6>
                <h6 hidden id="idDeleteJabatan"></h6>
            </div>
            <div class="modal-footer justify-content-between">
                <button class="btn btn-primary" style="width:45%" onclick="delete_jabatan()">Yes</button>
                <button class="btn btn-secondary" style="width:45%" data-dismiss="modal">No</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="modal_form_insertupdate">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="insertUpdateModal">Tambah Data Jabatan</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            </div>
            <div class="card card-primary">
                <form role="form" id="form-insertupdate">
                    <div class="card-body">
                        <div class="form-group">
                            <label class="control-label">ID Jabatan</label>
                            <input name="IDJabatan" placeholder="ID Jabatan" id="IDJabatan" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label">Nama Jabatan</label>
                            <input name="NamaJabatan" placeholder="Nama Jabatan" id="NamaJabatan" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="err-cutiBulanan control-label">Cuti Bulanan</label>
                            <select name="CutiBulanan" id="CutiBulanan" class="form-control select2 CutiBulanan" style="width: 100%;">
                            </select>
                            @*<span class="help-block"></span>*@
                            <span id="spanCutiBulanan" class="err-cutiBulanan help-block"></span>
                        </div>
                       @* <label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>*@
                    </div>
                    <div class="card-footer d-flex">
                        <button type="button" id="btnSaveAddUpdate" onclick="add_jabatan()" class="btn btn-primary mx-auto" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

<div aria-live="polite" aria-atomic="true" style="position: relative; min-height: 200px;">

    <!-- Then put toasts within -->
    <div id="toastResult" class="toast" style="position: absolute; top: 0; right: 0;">
        <div class="toast-header">
            <i class="fa fa-check"></i>
            <strong class="mr-auto">Success</strong>
            <button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="toast-body">
            <h6 class="toast-body-header">Master Jabatan berhasil update.</h6>
        </div>
    </div>
</div>

@section BodyLibrary{

    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/jsgrid/demos/db.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/jsgrid/jsgrid.min.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
    <!-- Bootstrap Switch -->
    <script src="@Url.Content("~/AdminLTE/plugins/bootstrap-switch/js/bootstrap-switch.min.js")"></script>
    <!-- bootstrap color picker -->
    <script src="@Url.Content("~/AdminLTE/plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js")"></script>
    <!-- Select2 -->
    <script src="~/AdminLTE/plugins/select2/js/select2.full.min.js"></script>

}

@section AdditionalScript{
    <script type="text/javascript">
        var rowId;
        var rowName;
        var masterJabatanTable;
        var listCutiBulanan = "";

        jQuery(document).ready(function ($) {
            masterJabatanTable = $("#dataMasterJabatan").DataTable({
                "responsive": true,
                "autoWidth": false,
                "ajax": {
                    "datatype": 'json',
                    "url": '@Url.Action("LoadDataMasterJabatan")',
                    "type": 'POST',
                },
                "columns": [
                    { "data": "id_jabatan", "name": "id_jabatan"},
                    { "data": "nama_jabatan", "name": "nama_jabatan"},
                    { "data": "id_saldo_ulang_bulan", "name": "id_saldo_ulang_bulan"},
                    { "data": "created_by", "name": "created_by"},
                    { "data": "created_date", "name": "created_date"},
                    { "data": "changed_by", "name": "changed_by"},
                    { "data": "changed_date", "name": "changed_date"},
                    { "data": "action"},
                ]
            });
            loadDataSelect2();
        });

        @*jQuery(document).ready(function ($) {
            $.ajax({
                "datatype": 'json',
                "url": '@Url.Content("~/MasterSaldoUlangBulan/LoadDataSaldoUlangBulan")',
                "type": 'GET',
                "success": function (data) {
                    $("#CutiBulanan").html(data);
                },
                "error": function () {
                    var s = "<option value='-1'>-Select</option>";
                    $("#CutiBulanan").html(s);
                }
            })
        })*@

        $('.select2').select2();
        $('.CutiBulanan').parents('.bootbox').removeAttr('tabindex');

        @*
        $('#CutiBulanan').select2({
            dropdownParent: ("#modal_form_insertupdate"),
            multiple: false,
            allowClear: true,
            placeholder: '- Pilih Saldo Cuti Bulanan -',
            width: '100%',
            theme: 'bootstrap4',
            ajax: {
                url: '@Url.Content("~/MasterSaldoUlangBulan/GetDatatableAllSaldo")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data["data"], function (item) {
                            return {
                                text: item.id_saldo_ulang_bulan + ' - ' + item.jml_cuti_per_bulan,
                                id: item.id_saldo_ulang_bulan
                            }
                        })
                    };
                }
            }
        });
        *@

        function loadDataSelect2() {
            $.ajax({
                url: '@Url.Content("~/MasterSaldoUlangBulan/GetDatatableAllSaldo")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.id_saldo_ulang_bulan + ' - ' + item.jml_cuti_per_bulan,
                                id: item.id_saldo_ulang_bulan
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#CutiBulanan').select2({
                        dropdownParent: ("#modal_form_insertupdate"),
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Saldo Cuti Bulanan -',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.id_saldo_ulang_bulan + ' - ' + item.jml_cuti_per_bulan,
                                id: item.id_saldo_ulang_bulan
                            }
                        })
                    });
                }
            );
        }
        function unselect_select2() {
            $('#CutiBulanan').append($("<option/>").val('').text('')).val('');
            $('#CutiBulanan').val('').trigger("change");

        }
        function get_by_id_saldo_ubul(id_saldo) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Content("~/MasterSaldoUlangBulan/GetDataByIDSaldo")',
                type: 'POST',
                data: JSON.stringify({ "id" : id_saldo}),
                success: function (data) {
                   //$("#CutiBulanan").empty().append($("<option/>").val(data.response[0].id_saldo_ulang_bulan).text(data.response[0].jml_cuti_per_bulan)).val(data.response[0].id_saldo_ulang_bulan);
                    $('#CutiBulanan').val(data.response[0].id_saldo_ulang_bulan).trigger("change");

                    show_modal_insertupdate('UPDATE');
                },
                error: function () {
                    var s = "<option value='-1'></option>";
                    $("#CutiBulanan").html(s);
                }
            });
        }

        function get_id_delete(id) {
            $("#deleteJabatan").modal('show');
            rowName = $(event.target).closest('tr').find('td:nth-child(2)').text().replace(/\s+/g, ' ').trim();
            rowId = id;//$(event.target).closest('tr').find('td:nth-child(1)').text().replace(/\s+/g, '').trim();
            var strConfirm = 'Hapus data karyawan dengan nama ' + rowName + '?';
            $("#deleteJabatanBody").text(strConfirm);
        }

        function show_modal_insertupdate(action) {
            save_method = action;
            if (action == 'ADD') {
                $("#IDJabatan").attr('readonly', false);
                document.getElementById("form-insertupdate").reset();
                $('.form-group').removeClass('has-error');
                $('.help.block').empty();
                //$('#CutiBulanan').empty();
                unselect_select2();
                $("#insertUpdateModal").text("Tambah Data Jabatan");
            } else {
                $("#insertUpdateModal").text("Ubah Data Jabatan");
            }
            $("#modal_form_insertupdate").modal('show');
        }

        function reload_table() {
            masterJabatanTable.ajax.reload(null, false);
        }

        function delete_jabatan(rowId) {
            if (rowId != null) {
                rowName = $(event.target).closest('tr').find('td:nth-child(2)').text().replace(/\s+/g, ' ').trim();

                Swal.fire({
                    title: 'Konfirmasi',
                    text: "Apakah Anda yakin menghapus data dengan ID Jabatan " + rowName + "?",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Hapus Data',
                    confirmButtonClass: 'btn btn-primary',
                    cancelButtonClass: 'btn btn-danger ml-1',
                    showLoaderOnConfirm: true,
                    buttonsStyling: false,
                    preConfirm: (delete_part) => {
                        return fetch('@Url.Content("~/MasterJabatan/Delete")' + "/" + rowId, {
                            method: 'POST'
                        }).then(response => {
                            if (!response.ok) {
                                return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                            }
                            return response.json();
                        }).then(result => {
                            if (result.response.Code === '200') {
                                reload_table();
                                return toastr.success('Data karyawan dengan ID Jabatan <strong>' + rowId + '</strong> berhasil dihapus.', 'Success!', { "timeOut": 5000 });
                            } else {
                                return toastr.warning('Gagal menghapus data karyawan dengan ID Jabatan <strong>' + rowId + '</strong>', 'Sorry!', { "timeOut": 5000 });
                            }
                        }).catch(error => {
                            Swal.showValidationMessage(
                                `Request failed: ${error}`
                            )
                        })
                    },
                    allowOutsideClick: () => !Swal.isLoading()
                });
            }
        }

        function edit_jabatan(rowId) {
            document.getElementById("form-insertupdate").reset();
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();
            unselect_select2();
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataById")',
                type: 'POST',
                data: JSON.stringify({ "id": rowId }),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Get Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    Swal.close();
                    $('[name="IDJabatan"]').val(data["data"][0].id_jabatan);
                    $("#IDJabatan").attr("readonly", true);
                    $("#NamaJabatan").val(data["data"][0].nama_jabatan);
                    get_by_id_saldo_ubul(data["data"][0].id_saldo_ulang_bulan);
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                }
            });
        }



        function add_jabatan() {
            $(".err-cutiBulanan").css('color: black');
            $(".form-group").removeClass('has-error');
            $(".help-block").empty()
            var validate = true;
            if ($("#IDJabatan").val() == "" || !$("#IDJabatan").val().replace(/\s/g, '').length) {
                //$('#IDJabatan').parent().addClass('has-error');
                $('#IDJabatan').next().text('ID Jabatan Harus diisi');
                validate = false;
            }
            if ($("#NamaJabatan").val() == "" || !$("#NamaJabatan").val().replace(/\s/g, '').length) {
                //$('#NamaJabatan').parent().addClass('has-error');
                $('#NamaJabatan').next().text('Nama Jabatan Harus diisi');
                validate = false;
            }
            if ($("#CutiBulanan").val() == "") {
                $('#spanCutiBulanan').text('Cuti Bulanan harus diisi');
                $('.err-cutiBulanan').css('color: red');
               //$('#CutiBulanan').next().text('Cuti Bulanan harus diisi');
                validate = false;
            }
            if (!validate) return;

            if (save_method == 'ADD') {
                url = "@Url.Content("~/MasterJabatan/AddJabatan")";
                form = "form-insertupdate";
            }
            else if (save_method == 'UPDATE') {
                url = "@Url.Content("~/MasterJabatan/UpdateJabatan")";
                form = "form-insertupdate";
            }

            $.ajax({
                url: url,
                type: "POST",
                data: $('#' + form).serialize(),
                dataType: "JSON",
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    Swal.close();
                    if (data.response.Code == "200") {
                        $("#modal_form_insertupdate").modal('hide');
                        reload_table();
                        save_method == "ADD" ?
                            toastr.success("Data dengan ID Jabatan <strong>" + $("#IDJabatan").val() + "</strong> berhasil ditambahkan", "Success!", { "timeOut": 5000 }) :
                            toastr.success("Data dengan ID Jabatan <strong>" + $("#IDJabatan").val() + "</strong> berhasil diubah", "Success!", { "timeOut" : 5000});
                    } else {
                        save_method == "ADD" ?
                            toastr.warning("Gagal menambahkan data dengan ID Jabatan <strong>" + $("#IDJabatan").val() + "</strong>", "Sorry!", { "timeOut": 5000 }) :
                            toastr.warning("Gagal mengubah data dengan ID Jabatan <strong>" + $("#IDJabatan").val() + "</strong>", "Sorry!", { "timeOut": 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    $('#btnSaveAddUpdate').text('Save'); //change button text
                    $('#btnSaveAddUpdate').attr('disabled', false);
                    toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        @*$(function () {
            $("#dataMasterJabatan").DataTable({
                "responsive": true,
                "autoWidth": false,
            });
        });*@
    </script>
}
